Kerbal Space Program - Bug #455

Fuel is drawn from lower tanks when upper tanks have a fuel line attached
03/19/2013 09:43 AM - rspeed

Status: Closed Start date: 03/19/2013
Severity: Low % Done: 100%
Assignee:

Category: Parts

Target version:

Version: 0.191 Language: English (US)
Platform: Any Mod Related: No
Expansion:

Description

When a radially-mounted stack of tanks includes a fuel line running from an upper tank to the rocket core, fuel is drawn from the tank
below the tank with the fuel line before the upper tank is dry.

Steps to Reproduce
1. Construct a simple rocket consisting of a central stage with one or more tanks and engines.
2. Add a radially-mounted decoupler, then a stack of two or more tanks and an engine.
3. Launch the rocket and monitor fuel flow.
4. Note that fuel will initially drain from the upper radially-mounted tank, as expected.

5. Return to the VAB and attach a fuel line from the upper radially-mounted tank to the central stage's tank.
6. Launch the rocket and monitor fuel flow.

Observed Behavior

The radial engine will draw fuel from the lower tank.

Expected Behavior

The radial engine should draw fuel from the upper tank, as it would normally. The presence of a fuel line shouldn't affect this.

Notes

I no longer have a copy of 0.18 or 0.19.0 installed, so | can't test for this behavior in older versions.

History

#1 - 03/19/2013 05:08 PM - Hyratel
- Platform Windows added

I'd like to get a clarification on this - is there a running engine in the stack core? which way is the fuel line pointed - inwards or outwards?

#2 - 03/19/2013 06:02 PM - rspeed

In the example | gave above there is an engine both in the center stack and on the radially-mounted (outside) stack. If there is no engine in the center,
however, the bug isn't present.

The fuel line is pointing inwards. The fuel flows from the top outside tank to the center tank, keeping it full until the top outside tank is empty.

Some additional observations:

I've reproduced this bug in both 0.19.1 on Mac OS X and 0.18.2 on Windows. | forgot that | hadn't yet updated the game on my Windows machine
until | saw that you had marked this bug as Windows-only. Additionally, | can rule out add-ons as the Windows machine is 100% stock.

The bug will present itself if you place an additional fuel line from the center tank to the upper tank (creating a loop between the two) even when
there's no engine below the center tank. So essentially, fuel only has to be flowing through the inward fuel line for the bug to be triggered.

The outside lower tank seems to be draining slower than | would expect. I'm suspect that the outside engine is actually drawing from both of the tanks

03/13/2024 1/4




above it.

#3 - 03/20/2013 11:46 AM - gloowa
- Platform Any added
- Platform deleted (Windows)

For me it seems that the radial engine is taking fuel from correct tank - the upper one.
The engine draining the lower tank seems to be the central engine - try shutting it down - you'll notice that fuel in lower radial tank stopped draining.
After the lower tank is emptied, the central engine switches to draining fuel from top radial tank, then moves to central tank.

I'm gonna test this against 3 radial tanks setup.

#4 - 03/20/2013 11:48 AM - rspeed

| don't think it's possible to make that determination without running this setup in a debugging environment.
That said, is that even possible? | don't know of any situation where fuel will flow upward.

#5 - 03/20/2013 12:02 PM - gloowa
- File Bug 455 test craft.craft added

From my observations shutting down radial engines stop fuel drain from top tanks, while shutting down central engine stop fuel drain from bottom
tanks.

It seems that central engine is consuming fuel in reverse-ordered stack - with 3 radial tanks setup it begins in bottom one, moves to central one and
then to top one.

Radial engines consume fuel as expected.

#6 - 03/20/2013 12:09 PM - gloowa
- Description updated
- Status changed from New to Confirmed

- % Done changed from 0 to 10

#7 - 03/20/2013 12:46 PM - MBobrik

Is this even a bug ? From the central engine's point of view, is the lower radial tank the farthest upstream tank and is thus drained first.

#8 - 03/20/2013 12:57 PM - rspeed

That could certainly be the case, though I'd still classify it as a bug. Fuel shouldn't ever flow upward unless it's via a fuel line.

#9 - 03/21/2013 06:34 AM - Ted

- Description updated

Removed duplicate data.

#10 - 03/10/2014 12:57 PM - BloodyRain2k

| don't see this as a bug too, because the fuellines define the last tank that will be drained. So if you don't want the upper tanks to be drained last don't
attach the fuellines there.

Also if the fuellines don't drain their attached tank last what do you expect them to do instead?
Be attached to the upper, draining it like normal first, then when the upper is empty ignore the lower because their attached tank is then empty.

#11 - 03/10/2014 10:50 PM - rspeed
In general | would expect one of two behaviors, and only one in the the current design of KSP:
1. Since tanks drain downward, and are physically separate, fuel shouldn't flow upward unless there is a overt reason. A fuel line implies that there
is some pumping mechanism.
2. Stacks of tanks should combine into one logical tank (which would then drain all as one tank). | vaguely recall a mod that accomplished this.
Considering the second expected behavior, perhaps this would be better as a feature request.
The reason this is an issue is because | was trying to build a spacecraft that would partially drain its central core before the outer stages had

completely drained. Specifically, | wanted to mimic the behavior of Falcon Heavy, which will (eventually, once cross-feed is implemented) power three
of the main core's 9 engines using that core's own propellant. To mimic this behavior | attached a fuel line to one of the higher tanks on the outer
rocket cores, but the result was that the outer core engines were starved of fuel (due to the bottom tank draining into the central core) long before
their tanks were empty.

#12 - 11/24/2014 10:09 AM - Padishar

This is a well understood and well documented (here: http:/forum.kerbalspaceprogram.com/threads/64362-Fuel-Flow-Rules-%280-24-2%29)
consequence of the "fuel flow" mechanism.

#13 - 11/21/2015 10:13 AM - sal_vager
- Status changed from Confirmed to New

- % Done changed from 10 to 0

| agree this may be better as a feature request as fuel drain looks to be correct.

#14 - 11/21/2015 10:14 AM - sal_vager
- Status changed from New to Confirmed
- Severity changed from Normal to Low

- % Done changed from 0 to 10

Oops can't change it.

#15 - 11/22/2015 01:49 AM - rspeed

Eh, at this point I'd rather just leave it as-is. The behavior is certainly unexpected, but I'd rather make a feature request to have stacked tanks merge
together.

#16 - 11/23/2015 05:20 PM - Squelch

Testing the original craft in 1.0.5.1028 the following observations are made.

1. Fuel is drawn from the topmost tank first in the case of the none fuel line attached stack.

2. Fuel is seen to be drawn from the bottommost tanks of the fuel line attached stacks as well as the topmost. Middle remaining fullest.
3. Stacks with fuel lines are depleted first.

4. Detaching the fuel lines leaves all stacks being depleted top down.

5. Enabling decoupler crossfeed without fuel lines, sees the centre stack use its fuel before the outer stacks.

The behaviour of the fuel flow within a stack was changed in 1.0.5 to help with keeping the CoM low down on the craft by drawing from the furthest
tank from the demand (Usually top down), as well as the addition of the ability to control crossfeed on decouplers.

With this information, | draw the following conclusions.

1. The topmost down for none fuel line attached stacks is correct.

2. Fuel lines supplying the centre stack are the new demand for the outer tanks they are attached to. The furthest tank is now the bottom of the
stack. Fuel is also being used by the engine from the top.

3. The fuel line attached stacks are supplying both engines and the centre stack, so therefore empty first.

4. Detaching fuel lines appear to make the stacks behave as expected. Topmost down.

5. Enabling crossfeed shows that the centre stack is depleted first. It has two engines, so therefore higher demand.

According to the new rules, and my observations, the behaviour is now in keeping with expectations. With regard to the middle tank on fuel line
attached stacks, fuel is being demanded from both ends of the stack due to the fuel line becoming a demand from the top, and the engine demanding
from the bottom with both emptying the furthest tank in turn, therefore it remains fullest. This can be confirmed by removing the engines from the fuel
line attached stacks and observing the flow from bottom to top on those stacks.

The only anomaly that | see is a new behaviour where the crossfed centre stack is flaming out before the outer stacks. This could be due to the
double engine demand or the outer tanks taking precedence on any remaining fuel in the centre single tank. A freshly built craft in 1.0.5.1028 exhibits
the same behaviour.

To satisfy the expectations of the original report. Attach the fuel line from the bottom of the outer stack to the centre stack. Fuel will then be drawn
from the furtherst, or top tank first.

Confirmation of these observations, and satisfied expectations are welcome.

#17 - 07/17/2016 09:40 AM - TriggerAu
- Status changed from Confirmed to Needs Clarification

- % Done changed from 10 to 0

#18 - 08/07/2016 05:17 AM - TriggerAu

- Status changed from Needs Clarification to Closed
http://forum.kerbalspaceprogram.com/threads/64362-Fuel-Flow-Rules-%280-24-2%29

- % Done changed from 0 to 100

Closing this report out for now. If it is still occuring in the latest version of KSP please open a new report (and this one can be linked to it.) For best
results, the wiki contains really useful info for when creating a report http://bugs.kerbalspaceprogram.com/projects/ksp/wiki.

You can also ask questions about the bug cleanup in the forum here:
http://forum.kerbalspaceprogram.com/index.php?/topic/143980-time-to-clean-up-the-bug-tracker/ and tag @TriggerAu to get my attention

#19 - 11/03/2016 08:31 PM - rspeed

This was resolved (and then some) with the addition of the tank prioritization feature in 1.2.

Files

Bug_455_test_craft.craft 22.9 KB 03/20/2013 gloowa
